
#include "mainsystem.h"

// ccdpp
void mainsystem::ccdpp_main()
{
	// datatype for channels
	ccdpp_results buffer;
	ccdpp_parameters pixel;

	// local variables
	char biasMat[SZ_ROW][2];

	// init
	HEPSY_S(ccdpp_id) char bias=0;
	HEPSY_S(ccdpp_id) unsigned rowIndex=0;
	HEPSY_S(ccdpp_id) unsigned colIndex=0;

	// main functionality
	HEPSY_S(ccdpp_id) while(1)
	{HEPSY_S(ccdpp_id)

		HEPSY_S(ccdpp_id) for(rowIndex=0; rowIndex<SZ_ROW; rowIndex++)
		{HEPSY_S(ccdpp_id)

			HEPSY_S(ccdpp_id) for(colIndex=0; colIndex<SZ_COL+BIAS; colIndex++)
			{HEPSY_S(ccdpp_id)
				
				HEPSY_S(ccdpp_id) pixel = stim_channel_port->read();

				// If colIndex==SZ_COL or colIndex==(SZ_COL+1), the input from channel is a pixel for zero-bias adjustment
				// otherwise it is a pixel to store in buffer
				HEPSY_S(ccdpp_id) if( colIndex==SZ_COL )
				{

					HEPSY_S(ccdpp_id) biasMat[rowIndex][0]=pixel.values;

				}else if( colIndex==(SZ_COL+1) )
				{HEPSY_S(ccdpp_id)

					HEPSY_S(ccdpp_id) biasMat[rowIndex][1]=pixel.values;

				}else
				{
					HEPSY_S(ccdpp_id) buffer.values[rowIndex][colIndex] = pixel.values;
				}
			}

			// Compute average value of right most columns of image, i.e., pixels in biasMat with row = rowIndex
			HEPSY_S(ccdpp_id) bias = (biasMat[rowIndex][0] + biasMat[rowIndex][1]) / 2;

			// Correct zero-bias by subtracting to each element in row = rowIndex
			// the average error found for that row, i.e., bias
			HEPSY_S(ccdpp_id) for(colIndex=0; colIndex<SZ_COL; colIndex++)
			{HEPSY_S(ccdpp_id)

				HEPSY_S(ccdpp_id) buffer.values[rowIndex][colIndex] -= bias;
			}
		}

		// Write output value on channel (to cntrl)
		HEPSY_S(ccdpp_id) result_ccdpp_channel->write(buffer);

		cout << "ccdpp: image sent to cntrl at time \t" << sc_time_stamp().to_seconds() << endl;

		HEPSY_P(ccdpp_id)		
	}
};
