
#include "mainsystem.h"

// cntrl
void mainsystem::cntrl_main()
{
	// datatype for channels

	/* part 1 - FDCT */
	ccdpp_results buffer_cntrl;
	codec_parameters codec_image_param;
	codec_results codec_image_result;
	codec_buffer_parameters buffer_codec;

	/* part 2 - quantization */
	cntrl_buffer_parameters buffer_cntrl_result;

	/* part 3 - send Data to UART */
	uat_parameters buffer_uat;

	// local variables
	int i, j, k, l;

	// init
	// Number of shifting position of each pixel of a 8x8 block 
    HEPSY_S(cntrl_id) const unsigned char QuantShiftTable[8][8] = {

        { 0, 0, 0, 0, 0, 0, 0, 0 },
        { 0, 0, 0, 0, 1, 1, 1, 1 },
        { 1, 1, 1, 1, 1, 1, 2, 2 },
        { 2, 2, 2, 2, 2, 2, 2, 3 },
        { 3, 3, 3, 3, 3, 3, 3, 4 },
        { 4, 4, 4, 4, 4, 4, 5, 5 },
        { 5, 5, 5, 5, 6, 6, 6, 6 },
        { 6, 7, 7, 7, 7, 8, 8, 8 }
    };

    // main functionality
	HEPSY_S(cntrl_id) while(1)
	{HEPSY_S(cntrl_id)

		// Read input from channel (from ccdpp)
		HEPSY_S(cntrl_id) buffer_cntrl = result_ccdpp_channel->read();

	    /* part 1 - FDCT */
	    // Consider a 8x8 block at a time
	   	HEPSY_S(cntrl_id) for(i=0; i<NUM_ROW_BLOCKS; i++)
		{HEPSY_S(cntrl_id)

	        HEPSY_S(cntrl_id) for(j=0; j<NUM_COL_BLOCKS; j++)
			{HEPSY_S(cntrl_id)

	            // push the 8x8 block and store in codec_image_param (iBuffer) 
	            HEPSY_S(cntrl_id) for(k=0; k<8; k++)
				{HEPSY_S(cntrl_id)

	                HEPSY_S(cntrl_id) for(l=0; l<8; l++)
					{HEPSY_S(cntrl_id)
						
						HEPSY_S(cntrl_id) int temp1 = i * 8 + k;
						HEPSY_S(cntrl_id) int temp2 = j * 8 + l;
						HEPSY_S(cntrl_id) codec_image_param.values[k][l] = buffer_cntrl.values[temp1][temp2];
	                }
	            }

	            /* perform FDCT on the 8x8 block*/

	            // Send parameters and receive results (with codec)
	            HEPSY_S(cntrl_id) codec_parameters_channel->write(codec_image_param);
	            HEPSY_S(cntrl_id) codec_image_result = codec_results_channel->read();

	            // pop the 8x8 block (from oBuffer) and store in buffer_codec 
	            HEPSY_S(cntrl_id) for(k=0; k<8; k++)
				{HEPSY_S(cntrl_id)

					HEPSY_S(cntrl_id) for(l=0; l<8; l++)
					{HEPSY_S(cntrl_id)

						
						HEPSY_S(cntrl_id) int temp1 = i * 8 + k;
						HEPSY_S(cntrl_id) int temp2 = j * 8 + l;
						HEPSY_S(cntrl_id)buffer_codec.values[temp1][temp2] = codec_image_result.values[k][l];
	                }
	            }
	        }
	    }

		cout << "cntrl: end FDCT at time \t" << sc_time_stamp().to_seconds() << endl;

	    /* part 2 - quantization of the image contained in buffer_codec*/
	    HEPSY_S(cntrl_id) for(i=0; i<NUM_ROW_BLOCKS; i++)
		{HEPSY_S(cntrl_id)

	        HEPSY_S(cntrl_id) for(j=0; j<NUM_COL_BLOCKS; j++)
			{HEPSY_S(cntrl_id)

	            /* quantize the 8x8 block in place */
	            HEPSY_S(cntrl_id) for(k=0; k<8; k++)
				{HEPSY_S(cntrl_id)

	                HEPSY_S(cntrl_id) for(l=0; l<8; l++)
					{HEPSY_S(cntrl_id)

					
					HEPSY_S(cntrl_id) int temp1 = i * 8 + k;
					HEPSY_S(cntrl_id) int temp2 = j * 8 + l;
					HEPSY_S(cntrl_id) buffer_cntrl_result.values[temp1][temp2] = buffer_codec.values[temp1][temp2] >> QuantShiftTable[k][l];
	                }
	            }
	        }
	    }

		cout << "cntrl: end quantization at time \t" << sc_time_stamp().to_seconds() << endl;

	    /* part 3 - send Data contained in buffer_cntrl_result to UART, 1 pixel at a time */
	    HEPSY_S(cntrl_id) for(i=0; i<SZ_ROW; i++)
		{HEPSY_S(cntrl_id)

	        HEPSY_S(cntrl_id) for(j=0; j<SZ_COL; j++)
			{HEPSY_S(cntrl_id)
				
	        	HEPSY_S(cntrl_id) buffer_uat.values = buffer_cntrl_result.values[i][j];

	        	// Write output pixel on channel (to uat)
	        	HEPSY_S(cntrl_id) result_cntrl_channel->write(buffer_uat);
	        }
	    }

	    HEPSY_P(cntrl_id)	    
	}
};
