/*
 * codec.cpp
 *
 *  Created on: 27 ott 2016
 *      Author: victor
 */


#include "mainsystem.h"

// codec 
void mainsystem::codec_main()
{

	// datatype for channels
	codec_parameters buffer_codec;
	codec_results output_codec;

	// local variables
	int x, y, z;
	short tempBuffer[8][8];
	double s[8], a, b;
	double r;
	short res;

	// init
	// Only 64 possible inputs to COS function
	// COS_TABLE contains all the possibile outputs of COS function 
	// Floating-point values multiplied by 32678 and rounded to nearest integer
	// (32678 to store each values in 2 bytes of memory)
	HEPSY_S(codec_id) const double COS_TABLE[8][8] = {

	    { 32768,  32138,  30273,  27245,  23170,  18204,  12539,   6392 },
	    { 32768,  27245,  12539,  -6392, -23170, -32138, -30273, -18204 },
	    { 32768,  18204, -12539, -32138, -23170,   6392,  30273,  27245 },
	    { 32768,   6392, -30273, -18204,  23170,  27245, -12539, -32138 },
	    { 32768,  -6392, -30273,  18204,  23170, -27245, -12539,  32138 },
	    { 32768, -18204, -12539,  32138, -23170,  -6392,  30273, -27245 },
	    { 32768, -27245,  12539,   6392, -23170,  32138, -30273,  18204 },
	    { 32768, -32138,  30273, -27245,  23170, -18204,  12539,  -6392 }
	};

	// main functionality
	HEPSY_S(codec_id) while(1)
	{HEPSY_S(codec_id)

		// Read input from channel (from cntrl)
		HEPSY_S(codec_id) buffer_codec = codec_parameters_channel->read();

		// For each pixel of the 8x8 block contained in buffer_codec apply FDCT
	    HEPSY_S(codec_id) for(x=0; x<8; x++)
		{HEPSY_S(codec_id)

			HEPSY_S(codec_id) for(y=0; y<8; y++)
			{HEPSY_S(codec_id)

			// 2 for cycles realize the double summation of the FDCT formula
			HEPSY_S(codec_id) for(z=0; z<8; z++)
			{HEPSY_S(codec_id)

	        		HEPSY_S(codec_id) r = 0;

					HEPSY_S(codec_id) s[z] = 0;

					
					HEPSY_S(codec_id) double temp1 = (COS_TABLE[0][y] / 32768.0);
					HEPSY_S(codec_id) s[z] = buffer_codec.values[z][0] * (temp1);
					
					HEPSY_S(codec_id) double temp2 = (COS_TABLE[1][y] / 32768.0);
					HEPSY_S(codec_id) double temp3 = buffer_codec.values[z][1] * temp2;
					HEPSY_S(codec_id) s[z] = s[z] + temp3 ;
					
					HEPSY_S(codec_id) double temp4 = (COS_TABLE[2][y] / 32768.0);
					HEPSY_S(codec_id) double temp5 = buffer_codec.values[z][2] * temp4;
					HEPSY_S(codec_id) s[z] = s[z] + temp5;
					
					HEPSY_S(codec_id) double temp6 = (COS_TABLE[3][y] / 32768.0);
					HEPSY_S(codec_id) double temp7 = buffer_codec.values[z][3] * temp6;
					HEPSY_S(codec_id) s[z] = s[z] + temp7;
					
					HEPSY_S(codec_id) double temp8 = (COS_TABLE[4][y] / 32768.0);
					HEPSY_S(codec_id) double temp9 = buffer_codec.values[z][4] * temp8;
					HEPSY_S(codec_id) s[z] = s[z] + temp9;
					
					HEPSY_S(codec_id) double temp10 = (COS_TABLE[5][y] / 32768.0);
					HEPSY_S(codec_id) double temp11 = buffer_codec.values[z][5] * temp10;
					HEPSY_S(codec_id) s[z] = s[z] + temp11;

					HEPSY_S(codec_id) double temp12 = (COS_TABLE[6][y] / 32768.0);
					HEPSY_S(codec_id) double temp13 = buffer_codec.values[z][6] * temp12;
					HEPSY_S(codec_id) s[z] = s[z] + temp13;
					
					HEPSY_S(codec_id) double temp14 = (COS_TABLE[7][y] / 32768.0);
					HEPSY_S(codec_id) double temp15 = buffer_codec.values[z][7] * temp14;
					HEPSY_S(codec_id) s[z] = s[z] + temp15;
	        	}

	        	HEPSY_S(codec_id) for(z=0; z<8; z++)
				{HEPSY_S(codec_id)

					HEPSY_S(codec_id) double temp1 = (COS_TABLE[z][x] / 32768.0);
					HEPSY_S(codec_id) double temp2 = s[z] * temp1;
					HEPSY_S(codec_id) r += temp2;
				}

				// Compute C(x)=a and C(y)=b of the FDCT formula

				//HEPSY_S(codec_id) a = ((x) ? (1.0) : (ONE_OVER_SQRT_TWO / 32768.0));
				HEPSY_S(codec_id)
				if (x)
				{
					HEPSY_S(codec_id) a=1.0;
				}
				else
				{
					HEPSY_S(codec_id) a=(ONE_OVER_SQRT_TWO / 32768.0);
				}

				//HEPSY_S(codec_id) b = ((y) ? (1.0) : (ONE_OVER_SQRT_TWO / 32768.0));
				HEPSY_S(codec_id)
				if (y)
				{
					HEPSY_S(codec_id) b=1.0;
				}
				else
				{
					HEPSY_S(codec_id) b=(ONE_OVER_SQRT_TWO / 32768.0);
				}

				HEPSY_S(codec_id) double temp1 = r * 0.25;
				HEPSY_S(codec_id) double temp2 = a * b;
				HEPSY_S(codec_id) res = (short) (temp1*temp2);

				// Store the result of the FDCT applied to 1 pixel of the 8x8 block into tempBuffer
				HEPSY_S(codec_id) tempBuffer[x][y]  = res;
	        }
	    }

	    HEPSY_S(codec_id) for(x=0; x<8; x++)
		{
	        HEPSY_S(codec_id) for(y=0; y<8; y++)
			{HEPSY_S(codec_id)

	        	HEPSY_S(codec_id) output_codec.values[x][y] = tempBuffer[x][y];
	        }
	    }

	    // Write output on channel (to cntrl)
	    HEPSY_S(codec_id) codec_results_channel->write(output_codec);

	    HEPSY_P(codec_id)
	    
	}
};
