#ifndef __DATATYPE__
#define __DATATYPE__

//////////////////////////////

#include <systemc.h>


#define SZ_ROW     16
#define SZ_COL     16
#define BIAS		2
#define NUM_ROW_BLOCKS SZ_ROW/8
#define NUM_COL_BLOCKS SZ_COL/8
#define ONE_OVER_SQRT_TWO 23170

/*--------------------------------------------------------------------------*/

////////////////////////////

// DATATYPES (i.e., MESSAGES) USED BY THE CHANNELS

////////////////////////////

// From stim_gen to cdpp
struct ccdpp_parameters
{
	char values;
};

// From cdpp to cnrtl
struct ccdpp_results
{
	char values[SZ_ROW][SZ_COL];
};

// From cntrl to codec
struct codec_parameters
{
	char values[SZ_ROW][SZ_COL];
};

// From codec to cntrl
struct codec_results
{
	short values[SZ_ROW][SZ_COL];
};

// Holds image after FDCT on each block (in cntrl)
struct codec_buffer_parameters
{
	short values[SZ_ROW][SZ_COL];
};

// Holds image after qauntization (in cntrl)
struct cntrl_buffer_parameters
{
	short values[SZ_ROW][SZ_COL];
};

// From cntrl to uat
struct uat_parameters
{
	short values;
};

// From uat to display 
struct sys_results
{
	short values;
};

//////////////////////////////

#endif
