#ifndef __DEFINE__
#define __DEFINE__

/////////////////////////////////////////////////////////////////////////////////////////////
// SBM INDEPENDENT: DO NOT CHANGE
/////////////////////////////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////////////////////////////

//// Tags for conditionl compilation (LP: To be provided as flag to compiler)
// Possible options:
//- NO TAGS (function alanalyzer = functional simulatoin + communications analysis + functional concurrency analysis)
//- TIMING_ENERGY (timing&energy simulation)
//- TIMING_ENERGY+CONCURRENCY (timing&energy simulation + timing concurrency analysis)
//- TIMING_ENERGY+LOAD (timing&energy simulation + load estimation)
//- TIMING_ENERGY+LOAD+CONCURRENCY (timing&energy simulation + load estimation + timing concurrency analysis) - WARNING: scheduler OVH is 0! 

#define _TIMING_ENERGY_
//#define _LOAD_
#define _CONCURRENCY_

//// Tags for debug and log (LP: To be provided as flag to compiler)
#define _DEBUG_
//#define _SAVE_CSV_
/////////////////////////////////////////////////////////////////////////////////////////////

//// Costants related to mapping files

#define APPLICATION "./XML/application.xml" // File for application

#define MAPPING_PS "./XML/mappingPS.xml" // File for processes-processors mapping

#define MAPPING_CH "./XML/mappingCH.xml" // File for logical links-physical links mapping

//// Costants related to processes/schedulers states and BB/modes

enum state { undefined, waiting, ready, running };

enum mode { off, suspended, active };

/////////////////////////////////////////////////////////////////////////////////////////////

//// Costants related to energy consumption estimation

// Method used to compute energy consumption (possible values: EPI/EPC) //LP: check formule
//#define energyComputation "EPI"
#define energyComputation "EPC"

/////////////////////////////////////////////////////////////////////////////////////////////

////////////////////////////
// SBM DEPENDENT
////////////////////////////

//// DC: costants related to the SBM

#define NPS 6 // Number of Processes (PS) in application.xml
enum p_id {stimulus_id, display_id, ccdpp_id, cntrl_id, codec_id, uat_id};
#define NCH 6 // Number of Channels (CH) in application.xml

#define NBB 4 // Number of BB in instanceTL.xml
enum bb_id { BB8051_0_id, BB8051_1_id, BBArtix7_0_id, BBArtix7_1_id };
#define NPL 11 // Number of physical link in instanceTL.xml

#endif
