#ifndef __MYSYSTEM__

#define __MYSYSTEM__

#include "define.h"
#include "sc_csp_channel_ifs.h"
#include "sc_csp_channel.h"
#include "datatype.h"
#include "SystemManager.h"

extern SystemManager *pSystemManager;

SC_MODULE(mainsystem)
{
	// Ports for testbench connections
	sc_port< sc_csp_channel_in_if< ccdpp_parameters > > stim_channel_port;
	sc_port< sc_csp_channel_out_if< sys_results > > result_channel_port;

	// PROCESSES

	// Process CCDPP
	void ccdpp_main();

	// Process CNTRL
	void cntrl_main();

	// process CODEC
	void codec_main();

	// Process huffman
	//void huffman_main();

	// Process huffman
	void uat_main();

	// CHANNELS

	// CNTRL
	sc_csp_channel< codec_parameters > *codec_parameters_channel;
	sc_csp_channel< codec_results > *codec_results_channel;

	// Inter-process connections
	sc_csp_channel< ccdpp_results > *result_ccdpp_channel;
	sc_csp_channel< uat_parameters > *result_cntrl_channel;

	SC_CTOR(mainsystem)
	{
		// Channels instantiation
		result_ccdpp_channel = new sc_csp_channel< ccdpp_results >(0);
		codec_parameters_channel = new sc_csp_channel< codec_parameters >(2);
		codec_results_channel = new sc_csp_channel< codec_results >(3);
		result_cntrl_channel = new sc_csp_channel< uat_parameters >(1);
		
		// Processes registration
		SC_THREAD(ccdpp_main);
		SC_THREAD(cntrl_main);
		SC_THREAD(codec_main);
		SC_THREAD(uat_main);

	}

};

#endif
