#include <systemc.h>
#include <stdio.h>
#include <assert.h>
#include "stim_gen.h"

extern bool stop_concurrency_sampling;

////////////////////////////

// STIMULUS: GENERATES INPUTS FOR THE SYSTEM

////////////////////////////

void stim_gen::main()
{

	FILE *imageFileHandle;
	int rowIndex=0, colIndex=0;
	int pixel;
	unsigned int i=1;
	ccdpp_parameters pixel_transmit;

	while(1)
	{
		// Open the file that stores the image
		imageFileHandle = fopen("./IMG/image.txt", "r");
		assert(imageFileHandle);
		rewind(imageFileHandle);
		
		cout << "Stimulus: start sending image at time \t" << sc_time_stamp().to_seconds() << endl;

		// Read image one pixel at a time 
		for(rowIndex=0; rowIndex<SZ_ROW; rowIndex++)
		{
			for(colIndex=0; colIndex<SZ_COL+BIAS; colIndex++)
			{
				if( fscanf(imageFileHandle, "%d", &pixel) == 1 )
				{
					assert( pixel >= -128 && pixel <= 127 );

					// Single pixel of the image 
					pixel_transmit.values = (char) pixel;
					// LP: temporizzare con wait(X, SC_US)?

					// Sends out pixel_transmit (to ccdpp)
					stim_channel_port->write(pixel_transmit);
					//cout << "Stimulus1-"<< i <<": \t" << pixel_transmit.values << "\t at time \t" << sc_time_stamp().to_seconds() << endl;
				}
			}			
		}

		cout << "Stimulus: image sent at time \t" << sc_time_stamp().to_seconds() << endl;

		// Close the file that stores the image (after all pixels of the image have been read)
		fclose(imageFileHandle);
//		stop_concurrency_sampling = true; // LP: dubbio
		return;
	}
}
