#ifndef __DATATYPE_H__
#define __DATATYPE_H__

#include <systemc.h>

////////////////////////////
// SBM DEPENDENT
////////////////////////////

// FFG DATATYPES (i.e., MESSAGES) TRANSFERRED BY MEANS OF CHANNELS

////////////////////////////

//FIR16

// Message from fir16m to fir16e
struct fir16e_parameters
{
	sc_uint<19> acc;
	sc_uint<9> coef[16];
	sc_uint<8> shift[16];
	sc_uint<8> sample_tmp;
};

// Message from fir16e to fir16m
struct fir16e_results
{
	sc_uint<19> acc;
};

// Message from fir16m to fir16s
struct fir16s_parameters
{
	sc_uint<8> shift[16];
	sc_uint<8> sample_tmp;
};

// Message from fir16s to fir16m
struct fir16s_results
{
	sc_uint<8> shift[16];
};

////////////////////////////

//FIR8

// Message from fir8m to fir8e
struct fir8e_parameters
{
	sc_uint<19> acc;
	sc_uint<9> coef[8];
	sc_uint<8> shift[8];
	sc_uint<8> sample_tmp;
};

// Messages from fir8e to fir8m
struct fir8e_results
{
	sc_uint<19> acc;
};

// Message from fir8m to fir8s
struct fir8s_parameters
{
	sc_uint<8> shift[8];
	sc_uint<8> sample_tmp;
};

// Message from fir8s to fir8m
struct fir8s_results
{
	sc_uint<8> shift[8];
};

////////////////////////////

//GCD

// Message from gcdm to gcde
struct gcde_parameters
{
	sc_uint<8> sample1;
	sc_uint<8> sample2;
};

// Message from gcde to gcdm
struct gcde_results
{
	sc_uint<8> result;
};

//////////////////////////////

#endif
