#ifndef __DEFINE__
#define __DEFINE__

/////////////////////////////////////////////////////////////////////////////////////////////
// SBM INDEPENDENT
/////////////////////////////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////////////////////////////

//// Tags for conditionl compilation (LP: To be provided as flag to compiler)
// Possible options:
//- NO TAGS (function alanalyzer = functional simulatoin + communications analysis + functional concurrency analysis)
//- TIMING_ENERGY (timing&energy simulation)
//- TIMING_ENERGY+CONCURRENCY (timing&energy simulation + timing concurrency analysis)
//- TIMING_ENERGY+LOAD (timing&energy simulation + load estimation)
//- TIMING_ENERGY+LOAD+CONCURRENCY (timing&energy simulation + load estimation + timing concurrency analysis) - WARNING: scheduler OVH is 0! 

#define _TIMING_ENERGY_
//#define _LOAD_
//#define _CONCURRENCY_

//// Tags for debug and log (LP: To be provided as flag to compiler)
#define _DEBUG_
//#define _SAVE_CSV_
/////////////////////////////////////////////////////////////////////////////////////////////

//// Costants related to mapping files

#define APPLICATION "./XML/application.xml" // File for application
#define MAPPING_PS "./XML/mappingPS.xml" // File for processes-processors mapping
#define MAPPING_CH "./XML/mappingCH.xml" // File for logical links-physical links mapping

//// Costants related to processes/schedulers states and BB/modes

enum state {undefined, waiting, ready, running};

enum mode {off, suspended, active};

/////////////////////////////////////////////////////////////////////////////////////////////

//// Costants related to energy consumption estimation

// Method used to compute energy consumption (possible values: EPI/EPC) //LP: check formule
//#define energyComputation "EPI"
#define energyComputation "EPC"

/////////////////////////////////////////////////////////////////////////////////////////////

////////////////////////////
// SBM DEPENDENT
////////////////////////////

//// FirFirGCD: costants related to the SBM

#define NPS 10 // Number of processes
enum p_id { stimulus_id, display_id, fir8m_id, fir8e_id, fir8s_id, fir16m_id, fir16e_id, fir16s_id, gcdm_id, gcde_id, s_fir8m_fir8e_id }; // Processes IDs
#define NCH 15 // Number of channels

#define TAP8 8 // FIR8
#define TAP16 16 // FIR16
#define NUMBER_OF_INPUTS 10

//// FirFirGCD: costants related to the HW architecture

#define NBB 5 // Number of BB instances in instanceTL
enum bb_id { BB8051_0_id, BB8051_1_id, BBleon3_0_id, BBleon3_1_id, BBArtix7_0_id }; // BBs IDs (#id in the tag is starting from 0 to be aligned with istancesTL)
#define NPL 3 // Number of physical link instances in instanceTL

#endif
