#ifndef __STIMGEN_H__
#define __STIMGEN_H__

#include <systemc.h>
#include "sc_csp_channel_ifs.h"
#include "define.h"

////////////////////////////

// STIMULUS: GENERATES INPUTS FOR THE SYSTEM (SBM DEPENDENT)

////////////////////////////

SC_MODULE(stim_gen)
{
	// Port for outputs to the channels
	sc_port < sc_csp_channel_out_if < sc_uint<8> > > stim1_channel_port;  	    
	sc_port < sc_csp_channel_out_if < sc_uint<8> > > stim2_channel_port;  	    

	// Used to stop concurrency sampling (to allow the simulation to finish), if needed
	bool stop_sampling1, stop_sampling2;

	// Main methods
	void stimulus1();
	void stimulus2();

	SC_CTOR(stim_gen)
	{
		SC_THREAD(stimulus1);
		SC_THREAD(stimulus2);

		// Used to stop concurrency sampling (to allow the simulation to finish), if needed
		stop_sampling1=false;
		stop_sampling2=false;
	}  

};

#endif
